Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestComputedAttributes.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestComputedAttributes.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.h2spatial/org.gvsig.h2spatial.h2gis132/org.gvsig.h2spatial.h2gis132.provider/src/test/java/org/gvsig/fmap/dal/store/h2/TestComputedAttributes.java	(revision 46050)
@@ -0,0 +1,393 @@
+package org.gvsig.fmap.dal.store.h2;
+
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+import junit.framework.TestCase;
+import static junit.framework.TestCase.assertEquals;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.DataManager;
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.feature.EditableFeature;
+import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.EditableFeatureType;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureQuery;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
+import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureAttributeEmulatorExpression;
+import org.gvsig.fmap.dal.store.jdbc.JDBCStoreParameters;
+import org.gvsig.fmap.dal.store.jdbc2.JDBCServerExplorer;
+import org.gvsig.tools.dispose.DisposeUtils;
+import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+public class TestComputedAttributes extends TestCase {
+    private static final Logger LOGGER = LoggerFactory.getLogger(TestComputedAttributes.class);
+    
+    public static final String DBNAME = "testCreate";
+    
+    public TestComputedAttributes(String testName) {
+        super(testName);
+    }
+    
+    @Override
+    protected void setUp() throws Exception {
+        super.setUp();
+        new DefaultLibrariesInitializer().fullInitialize();
+    }
+    
+    @Override
+    protected void tearDown() throws Exception {
+        super.tearDown();
+    }
+
+    // TODO add test methods here. The name must begin with 'test'. For example:
+    // public void testHello() {}
+    
+    protected String getProviderName() {
+        return DataStore.H2SPATIAL_PROVIDER_NAME;
+    }
+    
+    protected String getTargetName() {
+        return "testCreateTarget2";
+    }
+    
+    protected FeatureStore openTargetStore1(JDBCServerExplorer explorer) throws Exception {
+        JDBCStoreParameters params = explorer.get(getTargetName());
+        
+        DataManager dataManager = DALLocator.getDataManager();
+        FeatureStore store;
+        try {
+            store = (FeatureStore) dataManager.openStore(
+                    getProviderName(), 
+                    params
+            );
+        } catch(ValidateDataParametersException ex) {
+            LOGGER.warn(ex.getLocalizedMessageStack());
+            throw ex;
+        }
+        return store;
+    }
+
+    protected void createFrom(JDBCServerExplorer explorer, FeatureStore sourceStore) throws Exception {
+        NewFeatureStoreParameters params = (NewFeatureStoreParameters) explorer.getAddParameters(
+                getTargetName()
+        );
+        EditableFeatureType ft = params.getDefaultFeatureType();
+        ft.addAll(sourceStore.getDefaultFeatureType());
+        explorer.add(getProviderName(), params, true);
+    }
+    
+    protected void checkTypes(JDBCServerExplorer explorer, FeatureType sourceFeatureType) throws Exception {
+//        DataType STRING_TYPE = ToolsLocator.getDataTypesManager().get(DataTypes.STRING);
+//        DataType INT_TYPE = ToolsLocator.getDataTypesManager().get(DataTypes.INT);
+        
+        FeatureStore targetStore = openTargetStore1(explorer);
+        FeatureType targetFeatureType = targetStore.getDefaultFeatureType();
+
+        assertEquals("Feature type size",sourceFeatureType.size(), targetFeatureType.size());
+        for (int i = 0; i < sourceFeatureType.size(); i++) {
+            FeatureAttributeDescriptor sourceAttr = sourceFeatureType.get(i);
+            FeatureAttributeDescriptor targetAttr = targetFeatureType.get(i);
+            switch(sourceAttr.getType()) {
+                case DataTypes.BYTE:
+                case DataTypes.INT:
+                case DataTypes.LONG:
+                case DataTypes.BOOLEAN:
+                case DataTypes.DATE:
+                case DataTypes.STRING:
+                case DataTypes.TIME:
+                case DataTypes.TIMESTAMP:
+                case DataTypes.DOUBLE:
+                case DataTypes.FLOAT:
+                case DataTypes.DECIMAL:
+                    assertEquals(
+                            String.format("Field %s name mismatch", sourceAttr.getName()), 
+                            sourceAttr.getName(), 
+                            targetAttr.getName()
+                    );
+                    assertEquals(
+                            String.format("Field %s type mismatch", sourceAttr.getName()), 
+                            sourceAttr.getDataTypeName(), 
+                            targetAttr.getDataTypeName()
+                    );
+                    assertEquals(
+                            String.format("Field %s size mismatch", sourceAttr.getName()), 
+                            sourceAttr.getSize(),
+                            targetAttr.getSize()
+                    );
+                    assertEquals(
+                            String.format("Field %s precision mismatch", sourceAttr.getName()), 
+                            sourceAttr.getPrecision(),
+                            targetAttr.getPrecision()
+                    );
+                    assertEquals(
+                            String.format("Field %s scale mismatch", sourceAttr.getName()), 
+                            sourceAttr.getScale(),
+                            targetAttr.getScale()
+                    );
+                    break;
+                case DataTypes.GEOMETRY:
+                    assertEquals(
+                            String.format("Field %s name mismatch", sourceAttr.getName()), 
+                            sourceAttr.getName(), 
+                            targetAttr.getName()
+                    );
+                    assertEquals(
+                            String.format("Field %s type mismatch", sourceAttr.getName()), 
+                            sourceAttr.getDataTypeName(), 
+                            targetAttr.getDataTypeName()
+                    );
+                    assertEquals(
+                            String.format("Field %s geometry type mismatch", sourceAttr.getName()), 
+                            sourceAttr.getGeomType().getName(), 
+                            targetAttr.getGeomType().getName()
+                    );
+                    assertEquals(
+                            String.format("Field %s geometry SRS mismatch", sourceAttr.getName()), 
+                            sourceAttr.getSRS().toString(), 
+                            targetAttr.getSRS().toString()
+                    );
+                    assertEquals(
+                            String.format("Field %s size mismatch", sourceAttr.getName()), 
+                            sourceAttr.getSize(),
+                            targetAttr.getSize()
+                    );
+                    assertEquals(
+                            String.format("Field %s precision mismatch", sourceAttr.getName()), 
+                            sourceAttr.getPrecision(),
+                            targetAttr.getPrecision()
+                    );
+                    break;
+                default:
+                    fail(
+                        String.format("Field %s type %d (%s) not supported.", 
+                                targetAttr.getName(),
+                                targetAttr.getType(),
+                                targetAttr.getDataTypeName()
+                        )
+                    );
+            }
+        }
+    }
+    
+    protected void copyFrom(JDBCServerExplorer explorer, FeatureStore sourceStore, int mode) throws Exception {
+        FeatureStore targetStore = openTargetStore1(explorer);
+        targetStore.edit(mode);
+        try {
+            for (Feature sourceFeature : sourceStore.getFeatureSet()) {
+                EditableFeature targetFeature = targetStore.createNewFeature(sourceFeature);
+                targetStore.insert(targetFeature);
+            }
+        } finally {
+            targetStore.finishEditing();
+        }
+    }
+    
+    protected void checkData(JDBCServerExplorer explorer, FeatureStore sourceStore) throws Exception {
+        FeatureStore targetStore = openTargetStore1(explorer);
+
+        List<Feature> sourceFeatures = sourceStore.getFeatures();
+        List<Feature> targetFeatures = targetStore.getFeatures();
+        assertEquals("Count features", sourceFeatures.size(), targetFeatures.size());
+        for (int i = 0; i < targetFeatures.size(); i++) {
+            Feature sourceFeature = sourceFeatures.get(i);
+            Feature targetFeature = targetFeatures.get(i);
+            for (FeatureAttributeDescriptor sourceAttr : sourceStore.getDefaultFeatureType()) {
+                switch(sourceAttr.getType()) {
+                    case DataTypes.BYTE:
+                        assertEquals(
+                                String.format("Feature %03d attribute %s", i, sourceAttr.getName()),
+                                sourceFeature.getInt(sourceAttr.getName()),
+                                targetFeature.getInt(sourceAttr.getName())
+                        );
+                        break;
+                    case DataTypes.TIMESTAMP:
+                        Date sourceTimestamp = sourceFeature.getDate(sourceAttr.getName());
+                        Date targetTimestamp = targetFeature.getDate(sourceAttr.getName());
+                        assertEquals(
+                                String.format("Feature %03d attribute %s", i, sourceAttr.getName()),
+                                sourceTimestamp,
+                                targetTimestamp
+                        );
+                        break;
+                    case DataTypes.TIME:
+                        assertEquals(
+                                String.format("Feature %03d attribute %s", i, sourceAttr.getName()),
+                                sourceFeature.getDate(sourceAttr.getName()),
+                                targetFeature.getDate(sourceAttr.getName())
+                        );
+                        break;
+                    case DataTypes.GEOMETRY:
+                        assertEquals(
+                                String.format("Feature %03d attribute %s", i, sourceAttr.getName()),
+                                sourceFeature.get(sourceAttr.getName()),
+                                targetFeature.get(sourceAttr.getName())
+                        );
+                        break;
+                    case DataTypes.STRING:
+                    case DataTypes.INT:
+                    case DataTypes.LONG:
+                    case DataTypes.FLOAT:
+                    case DataTypes.DOUBLE:
+                    default:
+                        Object sourceValue = sourceFeature.get(sourceAttr.getName());
+                        Object targetValue = targetFeature.get(sourceAttr.getName());
+                        if( sourceValue == null ) {
+                            LOGGER.info(String.format("Feature %03d attribute %s is null", i, sourceAttr.getName()));
+                        }
+                        assertEquals(
+                                String.format("Feature %03d attribute %s", i, sourceAttr.getName()),
+                                sourceValue,
+                                targetValue
+                        );
+                }
+            }
+        }
+    }
+    
+    
+    public void testComputed1() throws Exception {
+        FeatureStore sourceStore = TestUtils.openSourceStore2();
+        JDBCServerExplorer explorer = TestUtils.openServerExplorer(DBNAME);
+        
+        createFrom(explorer, sourceStore);        
+        copyFrom(explorer, sourceStore, FeatureStore.MODE_APPEND);
+      
+        FeatureStore h2Store = openTargetStore1(explorer);
+        h2Store.edit();
+        FeatureType featureType = h2Store.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        eFeatureType.add("Compu1", 
+                DataTypes.INTEGER, 
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("ID*2")
+                ));
+        eFeatureType.add("Compu2", 
+                DataTypes.INTEGER, 
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("Poblacion+10000+Compu1")
+                ));
+        h2Store.update(eFeatureType);
+        h2Store.finishEditing();
+        List<Feature> features = h2Store.getFeatures();
+        for (int i = 0; i < features.size(); i++) {
+            Feature feature = features.get(i);
+            assertEquals("Compu1 "+i, feature.getInt("ID") * 2, feature.getInt("Compu1"));
+            if(feature.get("Poblacion")==null) {
+                assertEquals("Compu2 "+i, null, feature.get("Compu2"));
+            } else {
+                assertEquals("Compu2 "+i, feature.getInt("Poblacion") + 10000 + feature.getInt("Compu1"), feature.getInt("Compu2"));
+            }
+        }
+        DisposeUtils.dispose(h2Store);
+    }
+    
+    public void testComputed2() throws Exception {
+        FeatureStore sourceStore = TestUtils.openSourceStore2();
+        JDBCServerExplorer explorer = TestUtils.openServerExplorer(DBNAME);
+        
+        createFrom(explorer, sourceStore);        
+        copyFrom(explorer, sourceStore, FeatureStore.MODE_APPEND);
+      
+        FeatureStore h2Store = openTargetStore1(explorer);
+        h2Store.edit();
+        FeatureType featureType = h2Store.getDefaultFeatureType();
+        EditableFeatureType eFeatureType = featureType.getEditable();
+        FeatureQuery query = sourceStore.createFeatureQuery();
+        eFeatureType.add("CompuID", 
+                DataTypes.INTEGER, 
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("MOD(ID,10)")
+                ));
+        eFeatureType.add("CompuPob", 
+                DataTypes.INTEGER, 
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("Poblacion+1")
+                ));
+        eFeatureType.add("CompuProv", 
+                DataTypes.STRING, 
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("UPPER(Provincia)")
+                ));
+        EditableFeatureAttributeDescriptor extraColumn1 = 
+                query.getExtraColumn().add("ExtraID900", DataTypes.INTEGER);
+        EditableFeatureAttributeDescriptor extraColumn2 = 
+                query.getExtraColumn().add("ExtraPobDen", DataTypes.INTEGER);
+        EditableFeatureAttributeDescriptor extraColumn3 = 
+                query.getExtraColumn().add("ExtraAno", DataTypes.INTEGER);
+
+        extraColumn1.setFeatureAttributeEmulator(
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("CompuID+900")));
+        extraColumn2.setFeatureAttributeEmulator(
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("CompuPob+Densidad")));
+        extraColumn3.setFeatureAttributeEmulator(
+                new DefaultFeatureAttributeEmulatorExpression(
+                        eFeatureType, 
+                        ExpressionUtils.createExpression("EXTRACT(YEAR FROM Fecha)")));
+	
+        query.getGroupByColumns().add("Comunidad");
+        query.getGroupByColumns().add("CompuProv");
+        query.getGroupByColumns().add("ExtraAno");
+        query.getAggregateFunctions().put("ID", "MIN");
+        query.getAggregateFunctions().put("Poblacion", "MIN");
+        query.getAggregateFunctions().put("CompuID", "MIN");
+        query.getAggregateFunctions().put("CompuPob", "SUM");
+        query.getAggregateFunctions().put("ExtraID900", "SUM");
+        query.getAggregateFunctions().put("ExtraPobDen", "SUM");
+        h2Store.update(eFeatureType);
+        h2Store.finishEditing();
+        
+        
+        List<Feature> features0 = h2Store.getFeatures(query);
+        ArrayList<Feature> features = new ArrayList<>();
+        
+        System.out.println("ID,Comunidad,Provincia,Ciudad,Poblacion,Densidad,Fecha,CompuID,CompuPob,CompuProv,ExtraID900,ExtraPobDen,ExtraAno");
+        for (int i = 0; i < features0.size(); i++) {
+            Feature feature = features0.get(i);
+            features.add(feature.getCopy());
+	    System.out.print(feature.toString());
+	    System.out.print(","+feature.get("ExtraID900"));
+	    System.out.print(","+feature.get("ExtraPobDen"));
+	    System.out.println(","+feature.get("ExtraAno"));
+        }
+        System.out.println("ID,Comunidad,Provincia,Ciudad,Poblacion,Densidad,Fecha,CompuID,CompuPob,CompuProv,ExtraID900,ExtraPobDen,ExtraAno");
+	
+        features0 = null;
+	String[] header = new String[]{"ID","Comunidad","Provincia","Ciudad","Poblacion","Densidad","Fecha","CompuID","CompuPob","CompuProv","ExtraID900","ExtraPobDen","ExtraAno"};
+	ArrayList<Object[]> values = new ArrayList<Object[]>();
+	values.add(new Object[]{0, null, null, null, null, null, null, 0, null,"",900,null,null});
+	values.add(new Object[]{1, "GVA", null, null, 500, null, null, 1, 1502, "VALENCIA",1803,1505,2019});
+	values.add(new Object[]{3, "GVA", null, null, 50, null, null, 3, 352, "VALENCIA",1807,359,2020});
+	values.add(new Object[]{5, "GVA", null, null, 200, null, null, 5, 201, "ALICANTE",905,206,2019});
+	values.add(new Object[]{6, "GVA", null, null, 20, null, null, 6, 422, "ALICANTE",1813,1135,2020});
+	values.add(new Object[]{8, "GVA", null, null, 100, null, null, 8, 702, "CASTELLON",1817,719,2019});
+	for (int i = 0; i < features.size(); i++) {
+		for (int j = 0; j < header.length; j++) {
+			assertEquals("feature["+i+"]["+header[j]+"]:", values.get(i)[j],features.get(i).get(header[j]));
+		}
+	}
+
+        DisposeUtils.dispose(h2Store);
+    }
+    
+    
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/Statement.java	(revision 46050)
@@ -16,8 +16,12 @@
 
         public Code getCode(String id);
 
+        public void setOtherValues(Object otherValues);
+        
         public void setCodeClassifier(String classifier);
 
+        public Object getOtherValues();
+        
         public String getCodeClassifier();
 
         public CodeBuilder getCodeBuilder();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 46050)
@@ -7,7 +7,7 @@
 import org.gvsig.tools.util.PropertiesSupport;
 import org.gvsig.tools.util.PropertiesSupportHelper;
 
-public interface ExpressionBuilder {
+public interface ExpressionBuilder extends PropertiesSupport {
 
     public static final String OPERATOR_NOT = "NOT";
     public static final String OPERATOR_NEGATE = "NEGATE";
@@ -123,8 +123,8 @@
     public static final String FUNCTION_LIST = "LIST";
     public static final String FUNCTION_TUPLE = "TUPLE";
     public static final String FUNCTION_DICT = "DICT";
-    public static final String FUNCTION_$$CONSTANT = "$$CONSTANT";
-    public static final String FUNCTION_$$IDENTIFIER = "$$IDENTIFIER";
+    public static final String FUNCTION_$CONSTANT = "$CONSTANT";
+    public static final String FUNCTION_$IDENTIFIER = "$IDENTIFIER";
     
     public static final String FUNCTION_GETATTR = "GETATTR";
     public static final String FUNCTION_GETITEM = "GETITEM";
@@ -154,6 +154,7 @@
     public interface Value extends Visitable, PropertiesSupport {
         public String toString(Formatter<Value> formatter);
         public void replace(Value target, Value replacement);
+        public void copyPropertiesFrom(PropertiesSupport properties);
     }
 
     public interface Group extends Value {
@@ -217,6 +218,15 @@
         }
         
         @Override
+        public void copyPropertiesFrom(PropertiesSupport properties) {
+            for (Map.Entry<String, Object> entry : properties.getProperties().entrySet()) {
+                String key = entry.getKey();
+                Object value1 = entry.getValue();
+                this.setProperty(key, value1);
+            }
+        }
+        
+        @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
             if (filter == null || filter.accept(this)) {
                 visitor.visit(this);
@@ -550,4 +560,7 @@
     public String build(Formatter<Value> formatter);
     
     public String build();
+    
+    public void setProperties(Class filter, final Object... values);
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultStatement.java	(revision 46050)
@@ -459,9 +459,11 @@
                         break;
                     }
                     context.setCodeClassifier(String.valueOf(counter).trim());
+                    context.setOtherValues(counter);
                     for (Rule rule : rules) {
                         rule.parse(context);
                     }
+                    this.counter = (int) context.getOtherValues();
                     this.counter = this.counter + 1;
                 }
             } finally {
@@ -504,12 +506,13 @@
         @Override
         public void parse(StatementContext context) {
             context.trace(this.toString()+".parse");
-            String save = context.getCodeClassifier();
+            String saveCodeClassifier = context.getCodeClassifier();
             try {
                 this.counter = 1;
                 boolean breakloop = false;
                 while (!breakloop) {
                     context.setCodeClassifier(String.valueOf(counter).trim());
+                    context.setOtherValues(counter);
                     for (Rule rule : rules) {
                       try {
                         rule.parse(context);
@@ -518,10 +521,11 @@
                         break;
                       }
                     }
+                    this.counter = (int) context.getOtherValues();
                     this.counter = this.counter + 1;
                 }
             } finally {
-                context.setCodeClassifier(save);
+                context.setCodeClassifier(saveCodeClassifier);
             }
         }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 46050)
@@ -9,6 +9,7 @@
 import java.util.Date;
 import java.util.HashSet;
 import java.util.List;
+import java.util.Map;
 import java.util.Objects;
 import java.util.Set;
 import org.apache.commons.lang3.StringUtils;
@@ -26,6 +27,7 @@
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dataTypes.Coercion;
 import org.gvsig.tools.dataTypes.DataTypesManager;
+import org.gvsig.tools.util.PropertiesSupportHelper;
 
 @SuppressWarnings({"UseSpecificCatch" ,"OverridableMethodCallInConstructor"})
 public class DefaultExpressionBuilder implements ExpressionBuilder {
@@ -59,6 +61,7 @@
     private static final String FORMAT_OPERATOR_MULT = "({0} * {1})";
     private static final String FORMAT_OPERATOR_DIV = "({0} / {1})";
     private static final String FORMAT_OPERATOR_CONCAT = "{0} || {1}";
+    private final PropertiesSupportHelper propertiesHelper;
 
     public class GroupBase extends AbstractValue implements Group {
 
@@ -634,9 +637,40 @@
 
     public DefaultExpressionBuilder(ExpressionEvaluatorManager manager) {
         this.manager = manager;
+        this.propertiesHelper = new PropertiesSupportHelper();
     }
     
+        @Override
+    public Object getProperty(String name) {
+        return this.propertiesHelper.getProperty(name);
+    }
+
     @Override
+    public void setProperty(String name, Object value) {
+        this.propertiesHelper.setProperty(name, value);
+    }
+
+    @Override
+    public Map<String, Object> getProperties() {
+        return this.propertiesHelper.getProperties();
+    }
+    
+    @Override
+    public void setProperties(Class filter, final Object... values) {
+        for (int i = 0; i < values.length; i+=2) {
+              propertiesHelper.setProperty((String) values[i], values[i+1]);
+        }
+        this.accept(new Visitor() {
+            @Override
+            public void visit(Visitable v) {
+                for (int i = 0; i < values.length; i+=2) {
+                    ((Value)v).setProperty((String) values[i], values[i+1]);
+                }
+            }
+        }, new ClassVisitorFilter(filter) );
+    }
+    
+    @Override
     public Formatter<ExpressionBuilder.Value> formatter() {
       if( this.formatter == null ) {
         this.formatter = this.manager.getExpressionBuilderFormatter();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultCompiler.java	(revision 46050)
@@ -34,6 +34,7 @@
         private class State {
           public String codeClassifier;
           public Map<String,Code> codes;
+          public Object otherValues;
         }
         
         private State state;
@@ -100,11 +101,21 @@
         }
         
         @Override
+        public void setOtherValues(Object otherValues) {
+            this.state.otherValues = otherValues;
+        }
+        
+        @Override
         public void setCodeClassifier(String classifier) {
             this.state.codeClassifier = classifier;
         }
 
         @Override
+        public Object getOtherValues() {
+            return this.state.otherValues;
+        }
+        
+        @Override
         public String getCodeClassifier() {
             return this.state.codeClassifier;
         }
